using Syntriax.Engine.Core;
using Syntriax.Engine.Physics2D.Abstract;

namespace Syntriax.Engine.Physics2D;

public class Collider2DCircleBehaviour : Collider2DBehaviourBase, ICircleCollider2D
{
    private Circle _circleLocal = Circle.UnitCircle;

    public Circle CircleWorld { get; protected set; } = Circle.UnitCircle;
    public Circle CircleLocal
    {
        get => _circleLocal;
        set
        {
            _circleLocal = value;
            NeedsRecalculation = true;
        }
    }

    public override void CalculateCollider() => CircleWorld = Transform.Transform(_circleLocal);

    public Collider2DCircleBehaviour() { }
    public Collider2DCircleBehaviour(Circle circle) => CircleLocal = circle;
}
