namespace Syntriax.Engine.Systems.Tween;

public interface ITween
{
    event TweenEventHandler? OnStarted;
    event TweenEventHandler? OnPaused;
    event TweenEventHandler? OnResumed;
    event TweenEventHandler? OnCancelled;
    event TweenEventHandler? OnCompleted;
    event TweenEventHandler? OnEnded;

    event TweenEventHandler? OnUpdated;
    event TweenDeltaEventHandler? OnDeltaUpdated;

    TweenState State { get; set; }

    float Counter { get; }
    float Duration { get; }
    float Progress { get; }
    float Value { get; }

    delegate void TweenEventHandler(ITween sender);
    delegate void TweenDeltaEventHandler(ITween sender, float delta);
}

